import { List } from '@mezzy/collections';
import { Initializable } from '@mezzy/initializable';
import { IPromise, Result } from '@mezzy/result';
import { Signal } from '@mezzy/signals';
import IAnimation from './interfaces/iAnimation';
import IAnimationBatch from './interfaces/iAnimationBatch';
import IAnimationEventArgs from './interfaces/iAnimationEventArgs';
import AnimationManager from './animationManager';
export declare class AnimationBatch<TAnimationBatch extends IAnimationBatch> extends Initializable implements IAnimationBatch {
    constructor(animationManager?: AnimationManager, animations?: IAnimation[], isInitialize?: boolean);
    initialize(): IPromise<any>;
    private _signalMonitorTicked;
    private _signalMonitorCompleted;
    clear(): void;
    readonly animationManager: AnimationManager;
    protected p_animationManager: AnimationManager;
    readonly isCompleted: boolean;
    protected p_isCompleted: boolean;
    readonly isInterrupted: boolean;
    protected p_isInterrupted: boolean;
    readonly animations: List<IAnimation>;
    protected p_animations: List<IAnimation>;
    readonly result: Result<IAnimationBatch>;
    protected p_result: Result<IAnimationBatch>;
    ticked: Signal<IAnimationEventArgs[]>;
    completed: Signal<IAnimationEventArgs[]>;
    then(onDone: (value: TAnimationBatch) => any, onError?: (error: Error) => void): IPromise<any>;
    interrupt(): void;
}
export default AnimationBatch;
